summaryrefslogtreecommitdiff
path: root/t/am-prog-cc-stdc.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2013-01-18 13:13:30 +0100
committerStefano Lattarini <stefano.lattarini@gmail.com>2013-01-19 11:00:34 +0100
commiteada7ef7dfdee457c7e773ae96f435de81c2f0ce (patch)
tree1cfcee1830a510d283a22268fb983b02a46f5e21 /t/am-prog-cc-stdc.sh
parent81527ed5b4f5742bd01d69c7e556f63bf30fb6c8 (diff)
downloadautomake-eada7ef7dfdee457c7e773ae96f435de81c2f0ce.tar.gz
compat: reinstate AM_CONFIG_HEADER and AM_PROG_CC_STDC
Make them give runtime warnings in the obsolete category, but apart from that, make them behave as they did in Automake 1.12.x and earlier. While removing those macros seemed quite harmless, because it didn't put a real burden on the developers (requiring them just to do a quick edit to configure.ac), it turned out to place an unsustainable burden (or at least, a burden perceived as such) on distro packagers who use the latest Automake to bootstrap existing packages. Many of those packages, while having likely updated to AC_CONFIG_HEADERS in their development version, still used AM_CONFIG_HEADER in their existing released versions, and the removal of this macro would have thus forced the Fedora packagers to patch all of them. References: <http://www.mail-archive.com/devel@lists.fedoraproject.org/msg52840.html> <http://www.spinics.net/lists/fedora-devel/msg175922.html> <http://blog.flameeyes.eu/2013/01/autotools-mythbuster-automake-pains> In addition, the Fedora packagers have already decided to patch their Automake 1.13.1 to reinstate the AM_CONFIG_HEADER and AM_PROG_CC_STDC macros (plus other macros that I don't believe it's worth worrying about): <http://www.spinics.net/lists/fedora-devel/msg176098.html> <http://www.mail-archive.com/devel@lists.fedoraproject.org/msg53030.html> <http://pkgs.fedoraproject.org/cgit/automake.git/commit/?id=ffe6bc39> So, rather than having one more incompatibility floating around, we better mirror that change (or, actually, its relevant parts) in the upstream. * m4/obsolete-err.m4 (AM_CONFIG_HEADER, AM_PROG_CC_STDC): Revert to the older semantics, plus a runtime warning in the 'obsolete' category. * t/backcompat6.sh: Use AM_CONFIG_HEADER once again. * t/am-config-header-no-more.sh: Rename ... * t/am-config-header.sh: ... like this, and adjust. * t/am-prog-cc-stdc-no-more.sh: Rename ... * t/am-prog-cc-stdc.sh: ... like this, and adjust. * t/list-of-tests.mk: Adjust. * NEWS: Update. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't/am-prog-cc-stdc.sh')
-rwxr-xr-xt/am-prog-cc-stdc.sh44
1 files changed, 44 insertions, 0 deletions
diff --git a/t/am-prog-cc-stdc.sh b/t/am-prog-cc-stdc.sh
new file mode 100755
index 000000000..e3e469c73
--- /dev/null
+++ b/t/am-prog-cc-stdc.sh
@@ -0,0 +1,44 @@
+#! /bin/sh
+# Copyright (C) 2012-2013 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Check that the obsolete macro the obsolete macro AM_PROG_CC_STDC
+# still works.
+
+required=gcc
+. test-init.sh
+
+cat >> configure.ac <<'END'
+AM_PROG_CC_STDC
+AC_OUTPUT
+END
+
+echo bin_PROGRAMS = foo > Makefile.am
+
+$ACLOCAL
+$AUTOMAKE
+
+$AUTOCONF -Wnone -Wobsolete -Werror 2>stderr && { cat stderr >&2; exit 1; }
+cat stderr >&2
+grep "^configure\.ac:4:.*'AM_PROG_CC_STDC'.*obsolete" stderr
+grep "'AC_PROG_CC'.* instead" stderr
+
+echo 'int main (void) { return 0; }' > foo.c
+
+./configure
+$MAKE
+$MAKE distcheck
+
+: